import java.io.IOException;

import com.hms_networks.americas.sc.datapoint.DataPoint;
import com.hms_networks.americas.sc.datapoint.DataType;
import com.hms_networks.americas.sc.historicaldata.HistoricalDataQueueManager;
import com.hms_networks.americas.sc.realtimedata.RealTimeDataQueueManager;
import com.hms_networks.americas.sc.taginfo.TagInfoManager;

import exosite.ExositeService;
import java.util.ArrayList;
import java.lang.Thread;


public class ewonclass {
	private static constant STRING_TYPE = 4;

	public static void main(String[] args) throws Exception{
		/* Define Groups for realtime data reports
		   Group A = 0
		   Group B = 1
		   Group C = 2
		   Group D = 3
		*/
		int[] realtimegroups = new int[] {0,1};
		
		System.out.println("Starting Program");
		ExositeService exosite = new ExositeService();
		
		String[] cfg = exosite.readConfig();
		String host = cfg[0];
		int polling_rate =  Integer.parseInt(cfg[1]);
		
		String token = exosite.readToken(); 
		//String token = "";
		if (token == "")
		{
			System.out.println("Provisioning with Exosite");
			token = exosite.provision(host);
		}
		
		exosite.syncConfigIO(token, host);

		ArrayList datapointsReadFromQueue; 
		DataPoint data;
		int[] realtimedatagroupindex = realtimegroups;
		TagInfoManager.refreshTagList();
		RealTimeDataQueueManager.init();
		
		boolean startNewTimeTracker = !HistoricalDataQueueManager.doesTimeTrackerExist(); 
		// Forcing a new time tracker will reset the pointer of crawling through the HistoricalDataQueueManager
		//boolean startNewTimeTracker = true;
		while (true)
		{	
			long t1 = System.currentTimeMillis() / 1000;
			
			try {
				datapointsReadFromQueue = HistoricalDataQueueManager.getFifoNextSpanDataAllGroups(startNewTimeTracker);

				exosite.writeHistoricalData(datapointsReadFromQueue, token, host);
				if (startNewTimeTracker == true)
				{
					startNewTimeTracker = false;
				}
			} catch (IOException e) {
				e.printStackTrace();
			} catch (NumberFormatException ee) {
				ee.printStackTrace();
				startNewTimeTracker = true;
			}
			for (int j=0; j<realtimedatagroupindex.length; j++)
			{
				try {
					RealTimeDataQueueManager.dataFetcher(realtimedatagroupindex[j]);
					int data_size = RealTimeDataQueueManager.getNumGroupDataPoints(realtimedatagroupindex[j]);
											
					//Building data_in object
					String data_in = "{";
					for (int k=0; k<data_size; k++)
					{
						data = RealTimeDataQueueManager.getGroupNextData(realtimedatagroupindex[j]);
						if (data != null)
						{
							String value = data.getValueString();
							DataType d = data.getType();
							if (d.getRawDataType() == STRING_TYPE) {
								//Need to manually add quotes to make it valid JSON string
								value = '\"' + value + '\"';
							}
							data_in = data_in + "\"" + data.getTagId() + "\"" + ":" + value;
							if (k < data_size - 1)
							{
								data_in = data_in + ",";
							}
						}
					}
					data_in = data_in + "}";
					//System.out.print(data_in);
					int res = exosite.writeDataRealtime(data_in, token, host);
					System.out.print(res);
					
				} catch (NumberFormatException ee) {
					ee.printStackTrace();
					startNewTimeTracker = true;
				} catch (NullPointerException e) {
					e.printStackTrace();
					startNewTimeTracker = true;
				}
				
			}
			long t2 = System.currentTimeMillis() / 1000;

			if ((polling_rate - (t2 - t1)) >= 0)
			{
				// Don't just sleep the polling rate to account for computation time
				Thread.sleep((polling_rate - (t2 - t1)) * 1000);
			}
		}
	} 
}

